
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>讨喜的隔离可变性(九)混合使用角色和STM / iVAN</title>

    <meta name="description" content="讨喜的隔离可变性(九)混合使用角色和STM 角色可以帮助我们对可变状态进行很好地隔离.尤其是当问题能够被拆分成可以独立运行的多个并发任务.并且并发任务彼此之间都是通过消息进行异步通信时,角色的表现更佳.但是,角色并未提供对跨任务的一致性进行管理的方法.所以如果我们希望两个或多个角色的动作要么全部成功.要么全部失败,则角色就无法独立实现,而此时我们就需要通过引入STM来与角色配合完成此类功能.在本节中,我假定你已经阅读过第6章.以及本章中有关角色和类型化角色的相关内容. 我们在4.6节和6.9节中曾经实现过一个用于在两个Account之间转">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">讨喜的隔离可变性(九)混合使用角色和STM</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>角色可以帮助我们对可变状态进行很好地隔离。尤其是当问题能够被拆分成可以独立运行的多个并发任务、并且并发任务彼此之间都是通过消息进行异步通信时，角色的表现更佳。但是，角色并未提供对跨任务的一致性进行管理的方法。所以如果我们希望两个或多个角色的动作要么全部成功、要么全部失败，则角色就无法独立实现，而此时我们就需要通过引入STM来与角色配合完成此类功能。在本节中，我假定你已经阅读过第6章、以及本章中有关角色和类型化角色的相关内容。</p>
<p>我们在4.6节和6.9节中曾经实现过一个用于在两个Account之间转账的AccountService类，该类可以作为我们理解角色和STM之间这种相互作用的绝佳示例。在这个示例中，存款和取款这两个动作对于单个账户来说都是隔离的，所以Account可以用一个简单的角色或一个类型化角色来实现。然而转账动作需要一对儿跨越两个账户的存取款动作配合起来才能完成。换句话说，在一个完整的转账过程中，由某个角色所负责的存款动作若想成功，只有当且仅当另一个角色所负责的取款动作也成功时才能达成。下面就让我们用角色和STM混搭的方式来实现这个转账示例。</p>
<p>Akka提供了一些混合使用角色和STM的选项。例如，我们可以创建一个独立的事务协调对象，并手动将多个角色按顺序摆放在事务中（关于这一层次的控制细节，请参阅Akka的帮助文档）。除此之外，我们还有两种用于管理角色间事务的方法可供选择。我们将会在下面两节分别来研究这两种方法：即如何使用transactors以及如何协调类型化角色。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 14:15:21</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>讨喜的隔离可变性(九)混合使用角色和STM的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWQmxp.html" rel="bookmark">讨喜的隔离可变性&lpar;一&rpar;用角色实现隔离可变性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java将OOP变成了可变性驱动(mutability-driven)的开发模式[1],而函数式编程则着重强调不可变性,而这两种极端的方式其实都是有问题的.如果每样事物都是可变的,那么我们就需要妥善处理可见性和竞争条件.而在一个真实的应用程序中,也并非所有事物都是不可变的.即使是纯函数式语言也提供了代码限制区,在该区域内允许出现带副作用的逻辑以及按顺序执行这些逻辑的方法.但无论我们倾向于哪种编程模型,避免共享可变性都是毋庸置疑的. 共享可变性--并发问题的根源所在--是指多个线程可以同时更改相同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNjwG7M.html" rel="bookmark">讨喜的隔离可变性&lpar;六&rpar;多角色协作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在使用基于角色的编程模型时,只有当多个角色互相协作.同心协力解决问题时,我们才能真正从中获益并感受到其中的乐趣.为了更好地利用并发的威力,我们通常需要把问题拆分成若干个子问题.不同的角色可以负责不同的子问题,而我们则需要对角色之间的通信进行协调.下面我们将通过重写计算目录大小的例子来学习如何在进行多角色协作. 在4.2节中,我们写了一个计算给定目录下所有文件大小的程序.在那个例子中,我们启动了100个线程,每个线程都负责扫描不同的子目录,并在最后异步地将所有计算结果累加在一起.而本节中我们将看到			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQNNmz.html" rel="bookmark">讨喜的隔离可变性&lpar;八&rpar;类型化角色和Murmurs</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用了类型化角色的EnergySource使我们能够以调用函数的形式来掩盖后台顺序处理异步消息的过程,在实现了线程安全的同时又可以免去显式同步的困扰.虽然创建类型化角色并不困难,但此时我们的EnergySource却还是一个丢失了关键特性的半成品--即还没有可以周期性自动补充电量的能力. 在上一章我们所实现的版本中,由于整个动作都是在后台完成,所以电量补充的动作是不需要任何用户介入的.只要我们启动了电源,就会有一个专门的timer负责每秒钟为电源增加一格电量. 然而在使用了类型化角色的版本中,实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQn0Rp.html" rel="bookmark">讨喜的隔离可变性－前言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				曾有个的医嘱是这样说的:&quot;如果它伤到了你,那就别再用它了&quot;.在并发编程领域,共享可变性就是那个&quot;它&quot;. 虽然JDK的线程API使我们可以非常容易地创建线程,但如何防止线程冲突和逻辑混乱却又成了大问题.STM虽然可以解决部分问题,但是在一些类似Java这样的语言中,我们仍不得不非常小心谨慎地避免非托管可变变量和事务逻辑中产生某些副作用.而令人惊讶的是,当共享可变性消失的时候,所有那些令人纠结的问题也都随之消失了. 事实证明,在相同数据集上起多个线程互相冲突地执行是行不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Aw79z.html" rel="bookmark">讨喜的隔离可变性&lpar;十三&rpar;角色的特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于角色的并发模型降低了隔离可变性编程的难度,但该模型在适用场景上还是存在一些限制. 由于角色是通过消息来进行彼此间通信的,所以在那些没有强制不可变性的语言中,我们就必须人工来保证消息都是不可变的.传递可变消息将导致线程安全问题并最终使整个应用陷入共享可变性的险境当中,所以当手头的辅助工具还没有发展到可以帮助我们自动查验消息的不可变性之前,保证消息不可变性的重担暂时还是得由我们程序员来肩负. 角色都是各自异步运行的,彼此之前可以通过传递消息来进行协作.但某些角色的意外失败有可能导致其他角色饿死-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV06YYM.html" rel="bookmark">讨喜的隔离可变性&lpar;五&rpar;同时使用多个角色</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:本文是&lt;Java虚拟机并发编程&gt;的第五章,感谢华章出版社授权并发编程网站发布此文,禁止以任何形式转载此文. 在使用基于角色的编程模型时,只有当多个角色互相协作.同心协力解决问题时,我们才能真正从中获益并感受到其中的乐趣.为了更好地利用并发的威力,我们通常需要把问题拆分成若干个子问题.不同的角色可以负责不同的子问题,而我们则需要对角色之间的通信进行协调.下面我们将通过重写计算目录大小的例子来学习如何在进行多角色协作. 在4.2节中,我们写了一个计算给定目录下所有文件大小的程序.在那个例子中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXqoYKz.html" rel="bookmark">讨喜的隔离可变性（三）创建角色</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				正如前面曾经提到过的那样,虽然我们有很多支持角色的类库可供选择,但是在本书中我们将使用Akka.这是一个基于Scala的类库,该类库拥有非常好的性能和可扩展性.并同时支持角色和STM.此外,该类库还可以被用于多种JVM上的语言中.在本章中,我们将注意力集中在Java和Scala身上.而在下一章,我们将会学习如何在其他语言中使用Akka的角色.   图 8‑2 某个角色的生存周期 由于Akka是用Scala实现的,所以在Scala中创建和使用角色非常简单并且更加自然,从Akka API的实现里我们			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pddyVdp.html" rel="bookmark">讨喜的隔离可变性&lpar;十&rpar;使用Transactor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:本文是&lt;Java虚拟机并发编程&gt;的第五章,感谢华章出版社授权并发编程网站发布此文,禁止以任何形式转载此文. Akka transactor或事务角色为我们提供了一种将多个角色的执行过程合并到一个事务中的方法.顾名思义,transactor可以将多个角色对于托管STM Ref对象的更改变成原子操作,即仅当外围事务提交成功之后,对于那些托管对象的变更才能生效,否则所有的变更都会被丢弃. Transactor提供了三种处理消息的方法: 默认情况下,Transactor会在其自己的事务中处理消息			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba72Ynp.html" rel="bookmark">讨喜的隔离可变性&lpar;二&rpar;角色的特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				角色是一种能够接收消息.处理请求以及发送响应的自由运行的活动(activity),主要被设计用来支持异步化且高效的消息传递机制. 每个角色都有一个内建的消息队列,该队列与手机上所使用的短信队列十分相似.假设Sally和Sean同时给Bob的手机发了短信,则运营商将会把这两条短信都保存起来以便Bob在方便的时候取走.类似地,基于角色的并发库允许多个角色并发地发送消息.默认情况下,消息发送者都是非阻塞的:它们会先把消息发送出去,然后再继续处理自己的业务逻辑.类库一般会让特定的角色顺序地拾取并处理消息			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm6naz.html" rel="bookmark" class="title">VB 6&period;0能不能和手机上的微信软件进行通讯？怎么给微信软件发送消息？</a>
					<div>
						问题描述 VB 6.0能不能和手机上的微信软件进行通讯?怎么给微信软件发送消息? VB 6.0能不能和手机上的微信软件进行通讯?怎么给微信软件发送消息? 解决方案 微信有一套开发供调用的API,在VB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgVvOb.html" rel="bookmark" class="title">jsp  javaweb-http Stuts 500错误求大神解答</a>
					<div>
						问题描述 http Stuts 500错误求大神解答 就是同样一个jsp页面昨天还可以跑出来,今天一跑就是500错误弄了好久也没弄出来求解救,谢谢 . 解决方案 index.jsp的22行,看一下,什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnOyZz.html" rel="bookmark" class="title">从脚本编程的角度看JSP的安全</a>
					<div>
						JSP作为建立动态网页的技术正在不断升温.JSP和ASP.PHP.工作机制不太一样.一般说来,JSP页面在执行时是编译式,而不是解释式的.首次调用JSP文件其实是执行一个编译为Servlet的过程.当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boJRdz.html" rel="bookmark" class="title">揭开ASP脚本的执行顺序之迷</a>
					<div>
						首先我们先来了解一下ASP页面执行的流程:1.IIS找到ASP文件,提交给ASP引擎(一般是ASP.DLL)处理. 相信很多网站制作者和我一样,只注重了开发技术.技巧.却忽略了其原理,本文将对asp执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpk1Byb.html" rel="bookmark" class="title">Tomcat5&period;0&period;19与oracle8&period;1&period;7连接池配置指南</a>
					<div>
						oracle 作者:Junsan Jin 日期:2003-12-22 版本:1.2 2005-4-4 信箱:junsan21@126.com ; junnef21@sohu.com Blog:http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM18OKb.html" rel="bookmark" class="title">石榴算法是否是网站广告的终结者</a>
					<div>
						广告,是大多数网站生存的方式之一,甚至是一部份网站的全部收入来源.可以说,没有广告,不会有大批中小个人网站的产生,没有广告,不会有国内互联网的繁荣昌盛.但是从网站的根本功能来说,当然是为用户提供相关内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk24rrM.html" rel="bookmark" class="title">selenium-webdriver&lpar;python&rpar; &lpar;十四&rpar; webdriver原理简介</a>
					<div>
						之前看乙醇视频中提到,selenium 的ruby 实现有一个小后门,在代码中加上$DEBUG=1 ,再运行脚本的过程中,就可以看到客户端请求的信息与服务器端返回的数据:觉得这个功能很强大,可以帮助理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxXLob.html" rel="bookmark" class="title">透明窗体的又一实现</a>
					<div>
						前面拜读过本站无数高手的许多好文章,受益非浅,首先向各位大侠致敬!今天编程偶有小得,不敢独享,特拿出来与各位共享,希望对某些朋友有些许帮助. 透明窗体的问题相信大家已经很熟悉了,前面的几期在线杂志也有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2q6rp.html" rel="bookmark" class="title">后期小分享 简单步骤调出夏季清新薄荷色</a>
					<div>
						  夏天又来了,外面热得像烤炉一样,作为一个怕热更怕晒黑的小女生,我完全没有想出去拍摄的意思.前段时间发现学校后楼梯有一面浅蓝色墻,有一点点自然光,非常的赞,大概这个夏天会有一个固定的拍摄地方了. 这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKL86p.html" rel="bookmark" class="title">Win8&period;1打开便笺弹出stikynot&period;exe-Application Error错误怎么办</a>
					<div>
						win8.1系统中内置有便签应用,我们可以利用它来记录事情和工作内容.不过有用户反馈称打开便签时弹出了stikynot.exe-Application Error的错误提示,导致无法打开便签,这该怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwX98p.html" rel="bookmark" class="title">js实现在同一窗口浏览图片</a>
					<div>
						 在同一窗口浏览图片的方法有很多,本例要为大家介绍的是使用js获取img的src属性后进行替换,有此需要的朋友可以参考下 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwGXKb.html" rel="bookmark" class="title">win8怎么共享文件？</a>
					<div>
						  1.按键盘上[WIN+E]快捷键,进入我的电脑,然后找到您要共享的文件夹.点击鼠标右键选择[共享]--[高级共享] 2.进入共享属性后选择[高级共享]---勾选[共享此文件夹]---点击[权限]检 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXoBAp.html" rel="bookmark" class="title">win7电脑如何修复破损系统文件？</a>
					<div>
						  win7电脑如何修复破损系统文件?下面,咱们就来详细的看看这个SFC命令要如何来使用吧! 1.首先,咱们同时按下键盘上的win+R快捷键打开电脑的运行窗口,之后在窗口中输入cmd并单击回车,这样就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJOmkp.html" rel="bookmark" class="title">笔记本内存升级误区</a>
					<div>
						  什么样的本子需要升级内存? 众所周知,笔记本的升级空间相对不大,换U换显卡很难实现,所以只能吧升级空间放到可操作性更加灵活的内存上来,大多情况下升级内存也会使本子的性能得到一定的提升.但并不是说升 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmwW0z.html" rel="bookmark" class="title">带你了解&OpenCurlyDoubleQuote;不拘一格去创新，别出心裁入场景&rdquo;的锐捷</a>
					<div>
						大家可能关注过物联网.云计算.大数据等一些让人赞叹的高新科技,但是对将他们变为现实的行业魔术师却知之甚少,包括手机卖的很出名的华为.其实在这些高新科技的背后有许多不为大众所熟知的魔术师,刚刚年满17岁 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVN2m4z.html" rel="bookmark" class="title">Spark on Mesos&colon; 粗粒度与细粒度实现分析</a>
					<div>
						背景 顺着昨天spark standalone实现那篇文章继续扯淡,看看Mesos Scheduler的两种实现的异同. 对我来说,回过头再仔细看Spark在这一层的实现,思路又清晰了许多. Meso ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmKwab.html" rel="bookmark" class="title">MYSQL 函数汇总</a>
					<div>
						数值函数: 名字 描述                                                                                          ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB8PZb.html" rel="bookmark" class="title">谷歌推出简易版地图引擎 普通网民可定制地图</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 3月28日消息,据国外媒体报道,之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDewDWb.html" rel="bookmark" class="title">android-点击按钮时改变 imagebutton 的图像</a>
					<div>
						问题描述 点击按钮时改变 imagebutton 的图像 我想在程序中设置当点击和释放 imageButton 时,改变它的图像.当再次点击和释放时,图像就会被改回去,如何实现呢? 我试着使用 sel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEd82M.html" rel="bookmark" class="title">wpf datagrid 进入编辑模式的方式</a>
					<div>
						问题描述 wpf datagrid 进入编辑模式的方式 请教,wpf的datagrid怎么禁止双击某自定义列进入(退出)编辑模式,而是点击列中的button进入编辑模式 解决方案 在doublecli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkyXlM.html" rel="bookmark" class="title">大数据与移动设备的四点综述</a>
					<div>
						国外的媒体报道,如今的世界到处充斥着大数据.根据加拿大帝国商业银行的预测,未来的十年里,信息的增长将增加50倍.市场调研公司IDC也做出了类似预测,称2009年至2020年数据量将增长44倍. 移动设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgVJNM.html" rel="bookmark" class="title">对DLL的依赖关系</a>
					<div>
						问题描述 在VisualStudio2013里创建了两个项目:1.LibB:项目类型&quot;ClassLibrary&quot;,生成LibB.dll文件2.ExeA:项目类型&quot;Cons ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrq8Vyb.html" rel="bookmark" class="title">VoIP穿越NAT和防火墙的方法</a>
					<div>
						一.NAT/ALG 方式普通NAT是通过修改UDP或TCP报文头部地址信息实现地址的转换,但对于VOIP应用,在TCP/UDP净载中也需带地址信息,ALG方式是指在私网中的VOIP终端在净载中 填写的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nqwAz.html" rel="bookmark" class="title">ant flex 无&period;mxml文件要打成swf包 一种RLM的工程</a>
					<div>
						问题描述 ant flex 无.mxml文件要打成swf包 一种RLM的工程 以前别人留下的FLEX工程,现在要实现持续集成,这玩意要打成SWF包 却又没有.mxml文件 ,说是一个RLM工程,ant ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0neO6z.html" rel="bookmark" class="title">三星推出Exynox系列处理器专用于移动设备</a>
					<div>
						北京时间2月11日下午消息,三星电子宣布,将于本周五推出&quot;Exynos&quot;系列处理器,专用于手机.平板电脑及其他移动设备. 三星在一份声明中称,第一款Exynos处理器--初始代号为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NPaJz.html" rel="bookmark" class="title">总价3亿元和田籽料原石沪上露脸不到一年价格翻番</a>
					<div>
						今年以来,随着国民投资的不断增加,艺术品投资快速升温,而有中国&quot;国玉&quot;之称的和田玉投资也在迅速升温.记者了解到,在过去10年中,和田玉以每年30-50%的速度增值,从去年下半年至今 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYrarb.html" rel="bookmark" class="title">bigbluebutton webrtc-bigbluebutton 的端口打开问题</a>
					<div>
						问题描述 bigbluebutton 的端口打开问题 各位大神好! 我单位在安装了bigbluebutton 系统,在运行bigbluebutton/check 时总是会出现WebRTC echo t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1W2ob.html" rel="bookmark" class="title">Android开发笔记之&colon;一分钟学会使用Logcat调试程序的详解&lowbar;Android</a>
					<div>
						这是个很简单的问题,但每次隔一段时间后使用起来总是会出点乱子.这里记录下Logcat的步骤:1,在Activity里申明tag变量(名字其实是随便的,如下:private static final S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5Ldaz.html" rel="bookmark" class="title">在vs3下调试无误的pop3收信程序</a>
					<div>
						using System.Net.Sockets;using System.Collections;using System.IO;using System.Net;using System;usin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7Y6nM.html" rel="bookmark" class="title">JS动态的把左边列表添加到右边的实现代码&lpar;可上下移动&rpar;&lowbar;javascript技巧</a>
					<div>
						废话不多说了,直接给大家贴代码了,具体代码如下所示: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quo ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
